<?php
/**
 * All-in-One WP Migration Command
 * Copyright (C) 2014-2025 ServMask Inc.
 *
 * Modified Copyright (C) 2025 Lead Connector
 * 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if ( ! defined( 'ABSPATH' ) ) {
	die( 'Well Sir You Cannot Jump Here...haha' );
}

class Lcm_Import_Check_Decryption {

	public static function execute( $params ) {
		global $lcm_params;

		// Read package.json file
		$handle = lcm_open( lcm_package_path( $params ), 'r' );

		// Parse package.json file
		$package = lcm_read( $handle, filesize( lcm_package_path( $params ) ) );
		$package = json_decode( $package, true );

		// Close handle
		lcm_close( $handle );

		if ( ! empty( $params['decryption_password'] ) ) {
			if ( lcm_is_decryption_password_valid( $package['EncryptedSignature'], $params['decryption_password'] ) ) {
				$params['is_decryption_password_valid'] = true;

				$archive = new Lcm_Extractor( lcm_archive_path( $params ) );
				$archive->extract_by_files_array( lcm_storage_path( $params ), array( LC_MIGRATOR_DATABASE_BACKUP_FILE ), array(), array() );

				Lcm_Status::info( __( 'Decryption password validated.', 'lc-migrator' ) );

				$lcm_params = $params;

				return $params;
			}

			$decryption_password_error = __( 'The decryption password is not valid. The process cannot continue.', 'lc-migrator' );

			if ( defined( 'WP_CLI' ) ) {
				WP_CLI::error( $decryption_password_error );
			} else {
				Lcm_Status::backup_is_encrypted( $decryption_password_error );
				exit;
			}
		}

		return $params;
	}
}
